//+------------------------------------------------------------------+ 
// FXi 3 Semafor
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Green
#property indicator_color6 Red
//---- input parameters 
extern double Period1=5; 
extern double Period2=12; 
extern double Period3=0;
extern int Width1 = 2;
extern int Width2 = 1;
extern int Width3 = 3;
int Stp=1;
int Dev=1; 
extern int Symbol_1=159;
extern int Symbol_2=233;
extern int Symbol_22=234;
extern int Symbol_3=233;
extern int Symbol_33=234;
extern int BarsCount = 3000;
//+----    mod of  TRO MODIFICATION ------------------------+ 
extern string _____           ="       ";
extern bool   ShowAlert    = False ;
//---- buffers 
double FP_BuferUp[], FP_BuferDn[], NP_BuferUp[], NP_BuferDn[], HP_BuferUp[], HP_BuferDn[]; 
//+------------------------------------------------------------------+  
string symbol;  
int    digits, period, key  ; 
color tColor = Yellow ;
//+------------------------------------------------------------------+ 
int init()   { 
   period       = Period() ;     
   symbol       =  Symbol() ;
   digits       =  Digits ;  
   key=0; 
//+------------------------------------------------------------------+   
   if (Period1>0)   {
     SetIndexBuffer(0,FP_BuferUp);   SetIndexStyle(0,DRAW_ARROW,EMPTY,Width1);   SetIndexArrow(0,Symbol_1);   SetIndexEmptyValue(0,00);  SetIndexLabel(0,"FastUp");
     SetIndexBuffer(1,FP_BuferDn);   SetIndexStyle(1,DRAW_ARROW,EMPTY,Width1);   SetIndexArrow(1,Symbol_1);   SetIndexEmptyValue(1,00);  SetIndexLabel(1,"FastDn");
   }   
   if (Period2>0)   {
     SetIndexBuffer(2,NP_BuferUp);   SetIndexStyle(2,DRAW_ARROW,EMPTY,Width2);   SetIndexArrow(2,Symbol_2);   SetIndexEmptyValue(2,00);  SetIndexLabel(2,"MiddleUp");
     SetIndexBuffer(3,NP_BuferDn);   SetIndexStyle(3,DRAW_ARROW,EMPTY,Width2);   SetIndexArrow(3,Symbol_22);   SetIndexEmptyValue(3,00);  SetIndexLabel(3,"MiddleDn");
   }
   if (Period3>0)   {
     SetIndexBuffer(4,HP_BuferUp);   SetIndexStyle(4,DRAW_ARROW,EMPTY,Width3);   SetIndexArrow(4,Symbol_3);   SetIndexEmptyValue(4,00);  SetIndexLabel(4,"SlowUp");
     SetIndexBuffer(5,HP_BuferDn);   SetIndexStyle(5,DRAW_ARROW,EMPTY,Width3);   SetIndexArrow(5,Symbol_33);   SetIndexEmptyValue(5,00);  SetIndexLabel(5,"SlowDn");
   }
   return(0); 
  } 
//+------------------------------------------------------------------+ 
int deinit()   {    return(0);   } 
//+------------------------------------------------------------------+ 
int start()   { 
//+------------------------------------------------------------------+    
   if (Period1>0) CountZZ(FP_BuferUp,FP_BuferDn,Period1,Dev,Stp);
   if (Period2>0) CountZZ(NP_BuferUp,NP_BuferDn,Period2,Dev,Stp);
   if (Period3>0) CountZZ(HP_BuferUp,HP_BuferDn,Period3,Dev,Stp);
//+------------------------------------------------------------------+  
   if ( ShowAlert && key!=Time[0])    {     
     if( HP_BuferUp[0] != 0 )   Alert("     " + symbol+"   "+ Period()+ "      "+ DoubleToStr(Close[0] ,digits));
     if( HP_BuferDn[0] != 0 )   Alert("     "+ symbol+"   "+ Period()+ "      "+ DoubleToStr(Close[0] ,digits));
     if(Period2>=34)  {
       if( NP_BuferUp[0] != 0 && HP_BuferUp[0] == 0)   Alert("     " + symbol+"   "+ Period()+ "      "+ DoubleToStr(Close[0] ,digits));
       if( NP_BuferDn[0] != 0 && HP_BuferDn[0] == 0)   Alert("     "+ symbol+"   "+ Period()+ "      "+ DoubleToStr(Close[0] ,digits));
     }
   }
   key=Time[0];   
//+------------------------------------------------------------------+  
   return(0);
}
//+------------------------------------------------------------------+   
int CountZZ( double& ExtMapBuffer[], double& ExtMapBuffer2[], int ExtDepth, int ExtDeviation, int ExtBackstep )
  {
   int    shift, back,lasthighpos,lastlowpos, limit;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;
   limit=Bars-ExtDepth;
   if(limit>BarsCount) limit=BarsCount;   
   for(shift=limit; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=00;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=00;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=00; 
              }
           }
        } 
        
          ExtMapBuffer[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=00;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=00;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=00; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }
   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=limit; shift>=0; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=limit; shift>=0; shift--)
     {
      if(shift>=limit) ExtMapBuffer[shift]=00;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=00) ExtMapBuffer2[shift]=res;
        }
     }
   return(0);
 }
//+------------------------------------------------------------------+   
