//+------------------------------------------------------------------+
//|                                            Supertrend_triple.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color3 LimeGreen
#property indicator_width3 2
#property indicator_color2 Blue
#property indicator_width2 2
#property indicator_color1 Red
#property indicator_width1 3

extern bool Use_1 = true;
extern bool Use_2 = true;
extern bool Use_3 = true;
extern int 1=0;
extern int 2=5;
extern int 3=15;
extern int  CCI_Period=50;
extern int  ATR = 5;
extern int   = 1200;
double Trend[], Trend_mtf1[], Trend_mtf2[];
//+------------------------------------------------------------------+
int init() {
  if(Use_1) {
    SetIndexBuffer(2, Trend);  SetIndexStyle(2, DRAW_LINE);  }
  if(Use_2 && 2>1) {
    SetIndexBuffer(1, Trend_mtf1);   SetIndexStyle(1, DRAW_LINE);  }
  if(Use_3 && 3>2) {
    SetIndexBuffer(0, Trend_mtf2);   SetIndexStyle(0, DRAW_LINE);  }
  return(0);
 }
//+------------------------------------------------------------------+
int deinit() {  return(0); }
//+------------------------------------------------------------------+
int start() {
  int limit, i, y=0, counted_bars=IndicatorCounted();
  double  cciTrendNow;
  datetime TimeArray2[], TimeArray3[];

  if(counted_bars < 0) return(-1);
  if(counted_bars > 0) counted_bars--;

  limit=Bars-counted_bars;
  if(limit>) limit=;
  for(i = ; i >= 0; i--) {
    cciTrendNow = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, i);
     
    if (cciTrendNow > 0) {
       Trend[i] = Low[i] - iATR(NULL, 0, ATR, i);
       if (Trend[i] < Trend[i+1])  Trend[i] = Trend[i+1];
    }
    else if (cciTrendNow <= 0) {
       Trend[i] = High[i] + iATR(NULL, 0, ATR, i);
       if (Trend[i] > Trend[i+1])  Trend[i] = Trend[i+1];
    }
  }
    
   ArrayCopySeries(TimeArray2,MODE_TIME,Symbol(),2); 
   for(i=0,y=0;i<limit;i++)   {
     if (Time[i]<TimeArray2[y]) y++; 
     Trend_mtf1[i]=iCustom(NULL,2,"Supertrend_simple",CCI_Period,ATR,0,y);
  } 

    
   ArrayCopySeries(TimeArray3,MODE_TIME,Symbol(),3); 
   for(i=0,y=0;i<limit;i++)   {
     if (Time[i]<TimeArray3[y]) y++; 
     Trend_mtf2[i]=iCustom(NULL,3,"Supertrend_simple",CCI_Period,ATR,0,y);
  } 
  return(0);
 }
//+------------------------------------------------------------------+